---
import type { Config } from '@staticcms/core';
import mainCssUrl from '@staticcms/core/dist/main.css?url';

import StaticCMS from '~/components/cms/StaticCMS.svelte';
import { env } from '~/lib/env';
import { joinPaths } from '~/lib/path';

export const frontmatter = {
  title: 'Static CMS',
  order: 1,
  special: 'footer',
  hidden: !env.USE_CMS,
};

type InitOptions = {
  config?: Config;
  autoInitialize?: boolean;
};

const initOptions: InitOptions = {
  config: {
    backend: {
      name: 'git-gateway',
      branch: 'main',
    },
    media_folder: 'public/media',
    public_folder: joinPaths(env.BASE_URL, '/media'),
    local_backend: {
      url: 'http://localhost:8082/api/v1',
    },
    collections: [
      {
        name: 'pages',
        label: 'Pages',
        label_singular: 'Page',
        folder: 'src/pages',
        create: true,
        nested: {
          depth: 100,
          summary: '{{title}}',
          path: {
            index_file: 'index',
            label: 'Path',
          },
        },
        fields: [
          {
            label: 'Title',
            name: 'title',
            hint: 'The title of the page',
            widget: 'string',
          },
          {
            label: 'Layout',
            name: 'layout',
            widget: 'select',
            hint: 'The layout to use for this page',
            default: '~/layouts/Prose.astro',
            options: ['~/layouts/Prose.astro', '~/layouts/Default.astro', '~/layouts/Base.astro'],
          },
          {
            label: 'Order',
            name: 'order',
            hint: 'The order of the page. Highest number comes first. Use negative numbers to put pages at the end (lowest number goes last). Leave empty for alphabetical/default order.',
            widget: 'number',
            required: false,
          },
          {
            label: 'Special role',
            name: 'special',
            hint: 'The special role of the page',
            widget: 'select',
            required: false,
            options: ['footer'],
          },
          {
            label: 'Body',
            name: 'body',
            hint: 'The content of the page',
            widget: 'markdown',
          },
        ],
        summary_fields: ['title', 'order', 'special'],
        sortable_fields: {
          fields: ['title', 'order'],
          default: { field: 'order', direction: 'Descending' },
        },
      },
      {
        name: 'posts',
        label: 'Posts',
        label_singular: 'Post',
        folder: 'src/content/posts',
        create: true,
        slug: '{{year}}-{{month}}-{{day}}-{{slug}}',
        fields: [
          {
            label: 'Title',
            name: 'title',
            widget: 'string',
          },
          {
            label: 'Date',
            name: 'date',
            widget: 'datetime',
          },
          {
            label: 'Image',
            name: 'image',
            hint: 'The header image of this post',
            widget: 'image',
            required: false,
          },
          {
            label: 'Body',
            name: 'body',
            widget: 'markdown',
          },
        ],
        summary_fields: ['title', 'date'],
        sortable_fields: {
          fields: ['title', 'date'],
          default: { field: 'date', direction: 'Descending' },
        },
      },
    ],
  },
};
---

<!doctype html>
<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="robots" content="noindex" />
    <link rel="stylesheet" href={mainCssUrl} />

    <link rel="icon" type="image/svg+xml" href={joinPaths(env.BASE_URL, 'favicon.svg')} />
    <title>{env.SITE_TITLE} - Content Manager</title>
  </head>
  <body>
    <StaticCMS client:only="svelte" initOptions={initOptions} />
  </body>
</html>
